######################################################
#
# $Id: mcta.py 98 2008-01-21 07:12:31Z sebastian $
#
######################################################

import os
import SCons.Action
import SCons.Builder
import subprocess

def build_it(target, source, env):
    process = subprocess.Popen(
        [env['MCTA_TOOL']] +
        env['MCTA_GLOBAL_OPTS'].split() +
        env['MCTA_OPTS'].split() +
        map(str, source),
        stdout=open(str(target[0]), 'w'),
        stderr=open('/dev/null', 'w'))
    try:
        process.wait()
    except KeyboardInterrupt:
        os.kill(process.pid, 9)
        os.remove(str(target[0]))        
        raise
    return 0

def generate(env):
    env.Append(BUILDERS = {
        'Mcta': env.Builder(
        action = SCons.Action.Action(build_it,
                                     'mcta: $MCTA_OPTS $SOURCES'),
        target_factory = env.fs.File,
        )
        })

def exists(env):
    return True

