// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: ffassign.cpp 68 2008-01-14 09:09:37Z sebastian $
//
////////////////////////////////////////////////////////////////////

#include "ff_heuristic/ffassign.h"
#include "ff_heuristic/ffvar.h"
#include <ostream>

namespace ff {
    
    using namespace std;
    
    VarAssignment::VarAssignment(int32_t id, Variable* lhs, Variable* rhs) : 
	IntegerAssignment(id),
	lhs(lhs), 
	rhs(rhs) 
    {}

    ostream& VarAssignment::display(ostream& o) const {
	return o << lhs->getName() << " := " << rhs->getName();
    }
    
    ////////////////////////////////////////////////////////////////////
    
    ConstAssignment::ConstAssignment(int32_t id, Variable* lhs, int32_t rhs) : 
	IntegerAssignment(id),
	lhs(lhs), 
	rhs(rhs) 
    {}
    
    ostream& ConstAssignment::display(ostream& o) const {
	return o << lhs->getName() << " := " << rhs;
    }

    ////////////////////////////////////////////////////////////////////
    
    ostream& NullAssignment::display(ostream& o) const {
	return o << "no assign";
    }    
}
