// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: ffloc.h 73 2008-01-15 16:33:14Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef FF_LOC_H
#define FF_LOC_H

#include <inttypes.h>
#include <vector>
#include <string>
#include <iosfwd>

namespace ff {

    // forward declarations
    class Edge;
    
    class Location {
    private:
	std::string name;
	uint32_t id;
	std::vector<Edge*> edges;
    public:
	Location();

	void addEdge(Edge* edge);
	
	const std::vector<Edge*>& getEdges() const;
	uint32_t getID() const;
	void setID(uint32_t id);
	void setName(const std::string& name);
	const std::string& getName() const;
	std::ostream& display(std::ostream& o) const;
    };

    ////////////////////////////////////////////////////////////////////

    inline const std::vector<Edge*>& Location::getEdges() const {
	return edges;
    }
    
    inline uint32_t Location::getID() const {
	return id;
    }    
    
    inline void Location::setID(uint32_t id) {
	this->id = id;
    }
        
    inline const std::string& Location::getName() const {
	return name;
    }

    inline void Location::setName(const std::string& name) {
	this->name = name;
    }

    inline std::ostream& operator<<(std::ostream& o, const Location& loc) {
	return loc.display(o);
    }
}

#endif /* FF_LOC_H */
