// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: matrix.h 48 2008-01-07 17:09:18Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef GD_MATRIX_H
#define GD_MATRIX_H

#include <vector>
#include <iosfwd>
#include <inttypes.h>

class Matrix {
private:
    std::vector<int32_t> data;
    uint32_t size;
public:
    explicit Matrix(uint32_t size = 0);
    
    int32_t& at(uint32_t i, uint32_t j);
    int32_t at(uint32_t i, uint32_t j) const;
    void floyd_warshall();
    
    std::ostream& display(std::ostream& o) const;
};

inline std::ostream& operator<<(std::ostream& o, const Matrix& matrix) {
    return matrix.display(o);
}

#endif /* GD_MATRIX_H */
