// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: abststate.h 100 2008-01-22 13:15:55Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef ABSTSTATE_H
#define ABSTSTATE_H

#include "system/state.h"
#include <vector>
#include <iosfwd>

namespace pdb {
    
    class AbstractSystem;
    
    class AbstractState {
    public:
	std::vector<int32_t> locations;
	std::vector<int32_t> intvalues;
	int32_t distance;
	dbm::dbm_t zone;       

	static AbstractSystem* system;
	
	AbstractState();	
	AbstractState(AbstractSystem* sys);

	void addClockConstraint(int32_t i, int32_t j, raw_t bound);	
	std::ostream& display(std::ostream& o) const;
	int32_t hashKey() const;
	bool discEqual(const AbstractState& other) const;
    };

    ////////////////////////////////////////////////////////////////////

    inline std::ostream& operator<<(std::ostream& o, const AbstractState& as) {
	return as.display(o);
    }    
}

#endif /* ABSTSTATE_H */
