// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: pdb-builder.h 100 2008-01-22 13:15:55Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef INCLUDE_PDB_BUILDER_H
#define INCLUDE_PDB_BUILDER_H

#include <vector>
#include <iosfwd>

namespace pdb {
    class AbstractSystem;
    class AbstractState;
    class Hash;
    
    class PDBBuilder {
	AbstractSystem* system;
	AbstractState* state;
	Hash* hash;
    public:
	PDBBuilder(AbstractSystem* system);
	void addDistance(int32_t dist);
	void addLocation(int32_t loc);
	void addIntegerValue(int32_t val);
	void addClockConstraint(int32_t i, int32_t j, int32_t bound);
	
	void dump() const;
	int32_t lookup(const AbstractState* astate) const;
	AbstractSystem* getSystem() const;

	std::ostream& display(std::ostream& o) const;
    };
    
    ////////////////////////////////////////////////////////////////////

    inline std::ostream& operator<<(std::ostream& o, const PDBBuilder& builder) {
	return builder.display(o);
    }
}

#endif /* INCLUDE_PDB_BUILDER_H */
