// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: pdb.h 100 2008-01-22 13:15:55Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef PDB_HEURISTIC_H
#define PDB_HEURISTIC_H

#include "search/heuristic.h"
#include "pdb_heuristic/pdb-builder.h"
#include "pdb_heuristic/systembuilder.h"
#include <inttypes.h>
#include <vector>

class State;
class Task;

namespace pdb {

    class Process;
    class AbstractState;
    
    class PDBHeuristic : public Heuristic {
    private:
	PDBBuilder& builder;
	const Task* task;
	std::vector<uint32_t> proc_map;
	std::vector<uint32_t> var_map;
	std::vector<uint32_t> clock_map;

	void abstract(AbstractState& astate, const State* state) const;	
    public:
	PDBHeuristic(const Task* task);
        virtual int32_t eval(const State* state);
    };
}

#endif /* PDB_HEURISTIC_H */
