// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: systembuilder.cpp 100 2008-01-22 13:15:55Z sebastian $
//
////////////////////////////////////////////////////////////////////

#include "pdb_heuristic/systembuilder.h"
#include "pdb_heuristic/abstsys.h"
#include <iostream>
#include <cassert>

using namespace std;

namespace pdb {
    
    AbstractSystemBuilder::AbstractSystemBuilder() : 
	system(new AbstractSystem),
	currentproc(new Process),
	nrLocations(0)
    {
    }
    
    void AbstractSystemBuilder::addProcess(const char* name) {
	currentproc->setName(name);
	system->addProcess(currentproc);
	currentproc = new Process;
    }
    
    void AbstractSystemBuilder::addLocation(const char* name) {	
	currentproc->addLocation(new Location(name, currentproc, nrLocations++));
    }

    AbstractSystem* AbstractSystemBuilder::getSystem() const {
	return system;
    }

    void AbstractSystemBuilder::addInteger(const char* name) {
	system->addInteger(new Integer(name));
    }

    void AbstractSystemBuilder::addClock(const char* name) {
	system->addClock(new Clock(name));
    }
    
    ostream& AbstractSystemBuilder::display(ostream& o) const {
	return o << *system << endl;
    }
}
