// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: systembuilder.h 100 2008-01-22 13:15:55Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef INCLUDE_SYSTEM_BUILDER_H
#define INCLUDE_SYSTEM_BUILDER_H

#include <vector>
#include <iosfwd>

namespace pdb {
    class Process;
    class AbstractSystem;
    
    class AbstractSystemBuilder {
	AbstractSystem* system;
	Process* currentproc;
	int32_t nrLocations;
    public:
	AbstractSystemBuilder();
	void addProcess(const char* name);
	void addLocation(const char* name);
	void addInteger(const char* name);
	void addClock(const char* name);

	AbstractSystem* getSystem() const;

	std::ostream& display(std::ostream& o) const;
    };
    
    inline std::ostream& operator<<(std::ostream& o, const AbstractSystemBuilder& builder) {
	return builder.display(o);
    }
}

#endif /* INCLUDE_SYSTEM_BUILDER_H */
