// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: closedlist.h 68 2008-01-14 09:09:37Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef CLOSED_LIST_H
#define CLOSED_LIST_H

#include <ext/slist>
#include <ext/hash_map>
#include <inttypes.h>

class State;

class ClosedList {
private:    
    static const uint32_t initial_size = 7000000;

    typedef __gnu_cxx::slist<const State*> list_t;
    typedef __gnu_cxx::hash_map<uint32_t, list_t> hash_t;
    hash_t states;
    list_t smallStates;
    uint32_t nrStates;
public:
    ClosedList();
    
    bool insert(State* state);
    bool contains(const State* state) const;
    uint32_t size() const { return nrStates; }
};

#endif /* CLOSED_LIST_H */
