// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: succgen.h 73 2008-01-15 16:33:14Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef SUCCGEN_H
#define SUCCGEN_H

#include <vector>

class Transition;
class System;
class Edge;
class Invariant;
class State;

class SuccessorGenerator {
private:
    const System* system;

    void generateApplicableTransitions(const State* state, std::vector<const Transition*>& succs) const;
public: 
    bool delay(State* state) const;
    SuccessorGenerator(const System* system);

    void generateSuccessors(const State* state, std::vector<State*>& succs) const; 
};

#endif /* SUCCGEN_H */
