// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: trace.h 73 2008-01-15 16:33:14Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef TRACE_H
#define TRACE_H

#include <iosfwd>
#include <list>

class State;
class System;
class Transition;

class Trace {
private:
    const System* system;
    typedef std::list<const State*> list_t;
    list_t trace;
    
    std::ostream& dumpLocations(const State* state, std::ostream& o) const;
    std::ostream& dumpVariables(const State* state, std::ostream& o) const;
    std::ostream& dumpZone(const State* state, std::ostream& o) const;
    std::ostream& dumpTransition(const Transition* trans, std::ostream& o) const;

public:
    Trace(const System* system);
    void prepend(const State* state);
    std::ostream& display(std::ostream& o) const;
    uint32_t length() const { return trace.size() - 1; }

    std::ostream& dump(std::ostream& o) const;
};

inline std::ostream& operator<<(std::ostream& o, const Trace& trace) {
    return trace.display(o);
}

#endif /* TRACE_H */
