// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: constraintcontainer.h 16 2007-11-14 13:56:29Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef CONSTRAINT_CONTAINER_H
#define CONSTRAINT_CONTAINER_H

#include "system/expression.h"

class IntConstraint;
class ClockConstraint;
class Location;
class State;

class ConstraintContainer : public Expression {
protected:
    ConstraintContainer(Expression::type_t type) : Expression(type) {}
    virtual ~ConstraintContainer() {}
public:
    virtual void addIntConstraint(IntConstraint* ic) = 0;
    virtual void addClockConstraint(ClockConstraint* cc) = 0;
    virtual bool isSatBy(const State* state) const = 0;
};

#endif /* CONSTRAINT_CONTAINER_H */
