// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: effect.cpp 59 2008-01-11 15:26:44Z sebastian $
//
////////////////////////////////////////////////////////////////////

#include "system/effect.h"
#include "system/assignment.h"
#include "system/state.h"
#include "common/helper.h"
#include <ostream>
#include <cassert>

using namespace std;

Effect::Effect() :
    Expression(Expression::EFFECT),
    intassigns(),
    resets()
{}

Effect::~Effect() {
    // nothing to do. assignments and resets will be deleted by theire
    // factories
}

void Effect::apply(State* state) const {
    for (uint32_t i = 0; i < intassigns.size(); i++) {
	intassigns[i]->apply(state);
    }
    
    for (uint32_t i = 0; i < resets.size(); i++) {
	resets[i]->apply(state);
    }
}

ostream& Effect::display(ostream& o) const {
    if (intassigns.empty() && resets.empty())
    {
	return o;
    }
    o << "(effect ";
    printPtrVector(intassigns, ", ", o);
    if (!intassigns.empty() && !resets.empty()) {
	o << ", ";
    } 
    printPtrVector(resets, ", ", o);
    return o << ")";
}
