// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: guard.cpp 43 2007-12-14 14:25:39Z sebastian $
//
////////////////////////////////////////////////////////////////////

#include "system/guard.h"
#include "system/constraint.h"
#include "system/state.h"
#include "common/helper.h"

#include <ostream>
#include <cassert>

using namespace std;

Guard::Guard() :
    ConstraintContainer(Expression::GUARD) 
{}

Guard::~Guard() {
    intconstraints.destroy();
    clockconstraints.destroy();
}

void Guard::addIntConstraint(IntConstraint* ic) {
    intconstraints.add(ic);
}

void Guard::addClockConstraint(ClockConstraint* cc) {
    clockconstraints.add(cc);
}

ostream& Guard::display(ostream& o) const {
    if (intconstraints.empty() && clockconstraints.empty()) {
	return o;
    }
    o << "guard " << intconstraints;
    if (!intconstraints.empty() && !clockconstraints.empty()) {
	o << " && ";
    }
    return o << clockconstraints;
}

