// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: guard.h 43 2007-12-14 14:25:39Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef GUARD_H
#define GUARD_H

#include "system/constraintcontainer.h"
#include "system/constraint.h"

class State;

class Guard : public ConstraintContainer {
public:
    Conjunction<IntConstraint> intconstraints;
    Conjunction<ClockConstraint> clockconstraints;
    
    Guard();
    virtual ~Guard();
    
    virtual void addIntConstraint(IntConstraint* ic);
    virtual void addClockConstraint(ClockConstraint* cc);
    virtual bool isSatBy(const State* state) const;
    bool constrain(State* state) const;
    
    virtual std::ostream& display(std::ostream& o) const;
};

////////////////////////////////////////////////////////////////////

inline bool Guard::isSatBy(const State* state) const {
    return intconstraints.isSatBy(state) && clockconstraints.isSatBy(state);
}

inline bool Guard::constrain(State* state) const {
    return clockconstraints.constrain(state);
}

#endif /* GUARD_H */
