// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: invariant.cpp 43 2007-12-14 14:25:39Z sebastian $
//
////////////////////////////////////////////////////////////////////

#include "system/invariant.h"
#include "system/constraint.h"
#include "common/helper.h"
#include "common/message.h"
#include <ostream>
#include <cassert>

using namespace std;

Invariant::Invariant() : 
    ConstraintContainer(Expression::INVARIANT) 
{}

Invariant::~Invariant() {
    clockconstraints.destroy();
}

void Invariant::addIntConstraint(IntConstraint*) {
    error() << "int constraints are not supported in location invariants" << endl;
}

void Invariant::addClockConstraint(ClockConstraint* cc) {
    clockconstraints.add(cc);
}

ostream& Invariant::display(std::ostream& o) const {
    if (clockconstraints.empty()) {
	return o;
    }
    return o << "{" << clockconstraints << "}";
}
