// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: invariant.h 43 2007-12-14 14:25:39Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef INVARIANT_H
#define INVARIANT_H

#include "system/constraintcontainer.h"
#include "system/constraint.h"

class ClockConstraint;

class Invariant : public ConstraintContainer {
public:
    Conjunction<ClockConstraint> clockconstraints;

    Invariant();
    virtual ~Invariant();
    
    virtual void addIntConstraint(IntConstraint* ic);
    virtual void addClockConstraint(ClockConstraint* cc);
    virtual bool isSatBy(const State* state) const;
    bool constrain(State* state) const;

    virtual std::ostream& display(std::ostream& o) const;
};

////////////////////////////////////////////////////////////////////

inline bool Invariant::isSatBy(const State* state) const {
    return clockconstraints.isSatBy(state);
}

inline bool Invariant::constrain(State* state) const {
    return clockconstraints.constrain(state);
}


#endif /* INVARIANT_H */
