// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: location.h 59 2008-01-11 15:26:44Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef LOCATION_H
#define LOCATION_H

#include "system/variable.h"
#include <vector>

class Process;
class Invariant;
class Edge;

class Location : public Variable {
private:
    static uint32_t nrLocations;
public:
    Process* proc;
    bool urgent;
    bool commit;
    const uint32_t idInSystem;
    const uint32_t idInProcess;
    Invariant* inv;
    std::vector<Edge*> outgoing;

    Location(Process* proc, const std::string& name, int32_t idInProcess); 
    uint32_t getNrEdges() const;
    Edge* getEdge(uint32_t index) const;
    virtual ~Location();
    virtual std::ostream& display(std::ostream& o) const;
};

#endif /* LOCATION_H */
