// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: process.h 59 2008-01-11 15:26:44Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef PROCESS_H
#define PROCESS_H

#include "system/component.h"

class Location;
class Edge;
class System;

class Process : public Component {    
private:
    static uint32_t nrProcesses;
    
    std::vector<Location*> locs;
    std::vector<Edge*> edges;
public:
    const Location* init;
    const uint32_t id;
        
    Process(const std::string& name, Component* parent);
    virtual ~Process();
       
    void addLocation(Location* loc);
    
    uint32_t getNrLocations() const;
    Location* getLocation(uint32_t index) const;
    
    uint32_t getNrEdges() const;
    Edge* getEdge(uint32_t index) const;
    void addEdge(Edge* edge);

    Location* getLocationByName(const std::string& locname) const;
    virtual std::ostream& display(std::ostream& o) const;
};

#endif /* PROCESS_H */
