// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: system.h 102 2008-01-22 13:27:25Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef SYSTEM_H
#define SYSTEM_H

#include "system/component.h"

class Process;
class State;

class System : public Component {
public:    
    std::vector<Process*> procs;    

    System();
    virtual ~System();
    
    void addProcess(Process* proc);
    uint32_t getNrProcesses() const;
    Process* getProcess(uint32_t index) const;

    uint32_t getTotalNrClocks() const;
    uint32_t getTotalNrChannels() const;
    uint32_t getTotalNrIntegers() const;
    uint32_t getTotalNrLocations() const;
    uint32_t getTotalNrEdges() const;
    
    uint32_t getTotalNrIntAssignments() const;
    
    State* createInitial() const;
    bool isCommitted(const State* state) const;

    virtual uint32_t getNrChannels() const;

    virtual const Component* getComponent(const std::string& compname) const;
    virtual std::ostream& display(std::ostream& o) const;    
};

#endif /* SYSTEM_H */
