// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: systembuilder.h 1 2007-11-12 13:56:58Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef SYSTEMBUILDER_H
#define SYSTEMBUILDER_H

#include <string>
#include "common/utapfwd.h"

class System;
class Process;
class Location;
class Channel;
class ExpressionBuilder;
class Component;

class SystemBuilder {
private:
    ExpressionBuilder* ebuilder;

    void addInteger(const UTAP::variable_t& var, Component* comp) const;
    void addClock(const UTAP::variable_t& var, Component* comp) const;
    void addChannel(const UTAP::variable_t& var, Component* comp) const;
    void addConstant(const UTAP::variable_t& var, Component* comp) const;
    void addVariable(const UTAP::variable_t& var, Component* comp) const;
    void addProcess(const UTAP::instance_t& proc, System* system) const;
    void addLocation(const UTAP::state_t& state, Process* proc) const;    
    void addEdge(const UTAP::edge_t& edge, Process* proc) const;

    void setChannelType(const UTAP::type_t& type, Channel* channel) const;
    void setLocationType(const UTAP::type_t& type, Location* location) const;

public:
    SystemBuilder();
    ~SystemBuilder();
    System* buildSystem(UTAP::TimedAutomataSystem* system) const;
};

#endif /* SYSTEMBUILDER_H */
