// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: zone.cpp 102 2008-01-22 13:27:25Z sebastian $
//
////////////////////////////////////////////////////////////////////

#include "system/zone.h"
#include "system/system.h"
#include "system/variable.h"
#include "system/process.h"
#include <cassert>
#include <ostream>
#include <iomanip>

using namespace std;

MyClockAccessor::MyClockAccessor(const System* system) : 
    system(system) 
{}

const string MyClockAccessor::getClockName(cindex_t index) const {	
    uint32_t c = system->getNrClocks();
    if (index < c) {
	return system->getClock(index)->name;
    }
    index -= c;
    for (uint32_t i = 0; i < system->getNrProcesses(); i++) {
	const Process* p = system->getProcess(i);
	c = p->getNrClocks();
	if (index < c) {
	    return p->name + "." + p->getClock(index)->name;
	}
	index -= c;
    } 
    assert(false);
    return "";
}

ostream& dump(ostream& out, const dbm::dbm_t& zone) {
    for (uint32_t i = 0; i < zone.getDimension(); ++i) {
	for (uint32_t j = 0; j < zone.getDimension(); j++) {
	    out << setw(12) << zone(i,j) << " "; 
	}
	out << endl;
    }	
    return out;
}


