// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: ffuheur.cpp 87 2008-01-16 17:20:24Z sebastian $
//
////////////////////////////////////////////////////////////////////

#include "ul_heuristic/ffuheur.h"
#include "system/state.h"
#include "system/task.h"
#include "system/system.h"
#include "system/location.h"
#include "system/process.h"
#include "system/constraint.h"
#include "system/guard.h"
#include "system/effect.h"
#include "system/assignment.h"
#include <set>

namespace ff {
    using namespace std;

    FFUselessHeuristic::FFUselessHeuristic(const Task* task) :
	Useless(task),
	heuristic(new FFUHeuristic(task))
    {}
    
    int32_t FFUselessHeuristic::evalAbstracted(const State* state, const vector<bool>& abstracted) {
	heuristic->abstracted = &abstracted;
	return heuristic->eval(state);
    }
}
