// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: ffuheur.h 87 2008-01-16 17:20:24Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef FF_USELESS_HEUR_H
#define FF_USELESS_HEUR_H

#include "ff_heuristic/ffheur.h"
#include "ul_heuristic/useless.h"
#include "search/transition.h"

#include <vector>

class System;
class Edge;

namespace ff {
    class Edge;

    class FFUselessHeuristic : public Useless {
    private:
	////////////////////////////////////////////////////////////////////

	class FFUHeuristic : public FFHeuristic {
	public:
	    const vector<bool>* abstracted;
	    FFUHeuristic(const Task* task) : FFHeuristic(task), abstracted(NULL) {}
	    
	    virtual bool processEdge(const Edge* edge) {
		if ((*abstracted)[edge->id]) {
		    return false;
		}
		assigns.add(edge->getAssignments());
		return system->addToReachedLocations(edge->to);
	    }
	};

	////////////////////////////////////////////////////////////////////

	FFUHeuristic* heuristic;

	virtual int32_t evalAbstracted(const State* state, const std::vector<bool>& abstracted);
    public:
	FFUselessHeuristic(const Task* task);
    };
}

#endif /* FFUHEUR_H */
