// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: gdu.h 87 2008-01-16 17:20:24Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef GDU_H
#define GDU_H

#include "gd_heuristic/gd.h"
#include "ul_heuristic/useless.h"
#include <vector>
#include <ext/slist>
#include <ext/hash_map>

class State;
class Task;
class Edge;

class GDUselessHeuristic : public Useless {
protected:
    GDHeuristic* heuristic;
    virtual int32_t evalAbstracted(const State* state, const std::vector<bool>& abstracted);
public:
    GDUselessHeuristic(const Task* task, GDHeuristic* heuristic);
};

////////////////////////////////////////////////////////////////////

class GDSUMUselessHeuristic : public GDUselessHeuristic {
public:
    GDSUMUselessHeuristic(const Task* task) :
	GDUselessHeuristic(task, new GDSUMHeuristic(task)) 
	{}
};

////////////////////////////////////////////////////////////////////

class GDMAXUselessHeuristic : public GDUselessHeuristic {
public:
    GDMAXUselessHeuristic(const Task* task) :
	GDUselessHeuristic(task, new GDMAXHeuristic(task))
	{}
};

#endif /* GDU_H */
