// -*- mode: C++; c-file-style: "stroustrup"; c-basic-offset: 4; -*-
////////////////////////////////////////////////////////////////////
//
// $Id: useless.h 87 2008-01-16 17:20:24Z sebastian $
//
////////////////////////////////////////////////////////////////////

#ifndef USELESS_H
#define USELESS_H

#include "search/heuristic.h"
#include <vector>
#include <ext/slist>
#include <ext/hash_map>

class Task;
class Edge;
class State;

class Useless : public Heuristic {
protected:
    
    ////////////////////////////////////////////////////////////////////
    
    struct Entry {
	const State* state;
	const Edge* edge;
	const int32_t value;
	
	Entry(const State* state, const Edge* edge, int32_t value) :
	    state(state), edge(edge), value(value) {}
    };
    typedef __gnu_cxx::slist<Entry> list_t;
    typedef __gnu_cxx::hash_map<uint32_t, list_t> cache_t;
    
    ////////////////////////////////////////////////////////////////////

    cache_t uselessCache;
    
    const uint32_t nrEdges;
    std::vector<std::vector<bool>* > abstractedEdges;
    
    const Task* task;

    virtual bool isUseless(const State* state, int32_t heur);
    virtual bool isUseless(const State* state, const Edge* edge, int32_t heur);

    virtual void abstractEdges(const Edge* edge, std::vector<bool>& abstracted);
    virtual void abstractIntegers(const Edge* edge, std::vector<bool>& abstracted);
    virtual void abstractClocks(const Edge* edge, std::vector<bool>& abstracted);
        
    virtual int32_t evalAbstracted(const State* state, const std::vector<bool>& abstracted) = 0;
    virtual void abstractSystem(const Edge* edge, std::vector<bool>& abstracted);
public:
    Useless(const Task* task);    
    virtual int32_t eval(const State* state);
};

#endif /* USELESS_H */
